function [num_pre_edge, num_bingo, accuracy] = accuracy_network(A_real,A,pre)
% calculate the accuracy of an identified network
% Input
%  A_real: the real adjacent matrix;
%  A: the adjacent matrix of the predicted network
%  pre: precision, (the elements less than this level will be viewed as 0);
% Output
%  num_pre_edge: number of predicted edges;
%  num_bingo: number of edges predicted right;
%  accuracy: (r11+r22+r33)/n^2; where r11, r22 and r33 are the number of
%  correctly identified positives, zeros, and negatives;
%
    [n m]= size(A_real);
    num_pre_edge = nnz(abs(A)>=pre); 
    num_bingo = nnz(A_real~=0 & abs(A)>=pre);
    accuracy = nnz( A_real>0&A>=pre | A_real<0 &A<=-pre | A_real==0&abs(A)<pre)/(n*m);
end