function draw_points_cluster(Point,id_cluster)
% draw points with clusters
% Input:
%   Point:  2-by-n matrix, each column stands for a point on a plain;
%   id_cluster: Optional, a vector win n nonnegative integers indexing the cluster id
%      of each points, the elements 0: the point does not belong to any
%      cluster;

% plot the points
if nargin<2 
    plot(Point(1,:),Point(2,:),'*b');
    return
end

hold on
% plot the IDs

pad = (max(Point,[],2)-min(Point,[],2))/80;
for ii = 1:size(Point,2)
    text(Point(1,ii)+pad(1),Point(2,ii)-pad(2),sprintf('%d',ii),'FontSize',8);
end

color_cell = {'c','b','r','g',[0.8 0.5 0.3],'k'};

if ~isempty(id_cluster)
    for ii=0:max(id_cluster)
        iv = id_cluster ==ii;
        if ii+1<=length(color_cell)
            clr = color_cell{ii+1};
        else
            clr = rand(1,3);
        end
        if ~isempty(iv)
            plot(Point(1,iv),Point(2,iv),'o','MarkerEdgeColor',clr); %,'MarkerFaceColor',clr
        end
    end
end

hold off
end