function [id_cluster k]= indicate_cluster(X,percentage,k)
% identify the clusters by ssvd
% Inputs:
%   X: the cluster matrix, a square matrix with the order equal the point
%       numbers;
%   percentage: a scalar in (0,1), indicate the weight of dominated sigular
%       values;
%   k: Optional, the number of clusters;
% Outputs:
%   id_cluster: a column vecter, indicating the index of each points;
%   k: the number of clusters;


%k = 2; % number of  layers
param.merr = 1.0E-6;
param.gamu = 0.1;
param.gamv = 0.1;
param.threu = 2;
% param.niter = 5000;
%percentage = 0.999;
if nargin<=2
    [U s V k] = ssvd_k_layer(X,param,percentage);
else
    [U s V k] = ssvd_k_layer(X,param,percentage,k);
end
%%%
%U=full(U);
%V=full(V);
%save('../main/temp.mat','U','s','V','k');
%%%

lb = 0.4;
u1 = max(abs(U),[],1);
U = bsxfun(@rdivide,abs(U),u1);
[U_max id_cluster] = max(abs(U),[],2);
id_cluster(U_max<=lb)=0;      % the points that not include in any cluster

end