function H = kernelMatrix_OnceaLine(kernelName,A,B,r1)
% generate a kernel matrix H: H(i,j) = kernel(A(:,i),B(:,j))
%   kernelName: kernel name, such as 'rbf'
%   r1: kernel argument, Optional

[k m] = size(A);
[k2 n] = size(B);
if k~=k2
    error('the rows of input matices do not coincide');
end

H = zeros(m,n);
switch lower(kernelName)
	case 'rbf'
        if nargin<4
            r1 = 1/k;
        end
        if m<=n
            %U = zeros(k,n);
            for i = 1:m
                U = repmat(A(:,i),[1,n]) - B;
                H(i,:) = exp(-r1*sum(U.*U));        
            end
        else % m>n
            %U = zeros(k,m);
            for i = 1:n
                U = repmat(B(:,i),[1,m]) - A;
                H(:,i) = exp(-r1*sum(U.*U)');
            end
        end
    case 'product'     
        for i = 1:m
                U = repmat(A(:,i),[1,n]) - B;
                H(i,:) = sum(U.*U);        
        end
end 



