function A1 = set_promotion_repression(A,part_p)
% reset the existing interactions as promotion or repression randomly
%  
% Inputs:
%  A: the adjacent matrix of the network, 0: no interaction; 
%  part_p: a scaler in [0,1] indicating the part of number of interactions of
%       promotion to the number  of whole interactions;
% Outputs:
%  A1: the adjacent matrix with the interactions type (promotion or
%  repression) reset randomly, >0: promotion, <0 repression;

[I J Val] = find(A);
num = length(Val);
v = randperm(num);
p = round(num*part_p);
if p>0
    Val(v(1:p)) = abs(Val(v(1:p)));
end
if p<num
    Val(v(p+1:num)) = - abs(Val(v(p+1:num)));
end

A1 = sparse(I,J,Val);
if ~issparse('A')
    A1 = full(A1);
end
    
end