% generate representation matrix X

%networkFile = '../data/gene_network_hammer_14_nodes.mat';
%resultFile = '../data/rep_matrix_hammer_14_nodes.mat';

networkFile = '../data/Web100_023_net.mat';
resultFile = '../data/rep_matrix_Web100_023.mat';

load(networkFile,'adj_mat','id_cell');

% unitize each row of A_real
L = full(adj_mat);
d_sum = sqrt(sum(L.*L,2));
A_real = bsxfun(@times,1./(d_sum+~d_sum),L);

n = size(A_real,1);
m = round(0.8*n);
NUM = 30; % number of tested matrices

% generate a group of test reperesentation matrix
noiseDensity = 0;
X_noNoise = cell(NUM,1);
for ii=1:NUM
    x1 = rand(n,1);
    X_noNoise{ii} = generateRepMatrix(A_real,m,x1,noiseDensity);
end

noiseDensity = 0.1;
X_noise = cell(NUM,1);
for ii=1:NUM
    x1 = rand(n,1);
    X_noise{ii} = generateRepMatrix(A_real,m,x1,noiseDensity);
end

save(resultFile,'X_noise','X_noNoise','A_real','adj_mat');
