% compare clusters generated by BlockPCA-ssvd and k-means

% load data and clustering results by BlockPCA-ssvd 
dataStr = '3_cluster_30_point';
dataFile = sprintf('../data/clusterPoint/cluster_data_%s.mat',dataStr);
resultFile = sprintf('../iteration/blockPCA/BlockPCA_admm_%s.mat',dataStr);

load(dataFile,'Points');
load(resultFile,'id_cluster');

Points = Points';
id_cluster = id_cluster{3}; % with lambda1= 0.6 lambda2

% exclude points which do not belong to any clusters
% id_cluster = id_cluster{3}; % id_cluster{3}: lambda1 = 0.6 * lambda2
% I_id_0 = find(id_cluster==0);
% Points(I_id_0,:) = [];
% id_cluster(I_id_0,:) = [];

num_cluster = 3; % number of clusters

% cluster by k-means
[id_kmean] = kmeans(Points,num_cluster,'distance','sqeuclid');
[sil_kmean h]= silhouette(Points,id_kmean,'sqeuclid');

figName = ['silhouette_' dataStr];
saveas(h,sprintf('../figure/BlockPCA_admm/%s.fig',figName));
saveas(h,sprintf('../figure/BlockPCA_admm/%s.eps',figName),'psc2');
close(gcf);
% save the results
save('../iteration/cluster_kmean_point30.mat','Points','id_kmean','sil_kmean');

% put out the average silhouette value 
mean_sil_kmean = mean(sil_kmean);
mean_sil_pca = mean(silhouette(Points,id_cluster,'sqeuclid'));
fprintf('average silhouette value of kmean:\t%.3f\n',mean_sil_kmean);
fprintf('average silhouette value of blockPCA:\t%.3f\n',mean_sil_kmean);

% draw the points with clusters on a plane
h2= draw_points_cluster(Points',id_kmean);
title('cluster with k-means');
  % save the figure
solverStr = 'kmean';
figName = ['cluster_' solverStr '_' dataStr];
saveas(h2,sprintf('../figure/BlockPCA_admm/%s.fig',figName));
saveas(h2,sprintf('../figure/BlockPCA_admm/%s.eps',figName),'psc2');


