% test  geneNetwork() on web100 data

% argument
gamma1_v = [0.02 0.005 0.001];
gamma1_terminate = 0.005;
pre = 0.1;

str = ['_' date()]; %'';
networkFile = '../data/Web100_023_net.mat';
resultFile = sprintf('../iteration/cluter_accuracy_Web100_023%s.mat',str);
repFile = '../data/rep_matrix_Web100_023.mat';
clusterFile = sprintf('../iteration/cluster_community_Web100_023%s.txt',str);
outputNetworkFile= sprintf('../iteration/network_community_Web100_023%s.txt',str);
    % the file of the network predicted by the method based on community

% load reperesentation matrix
load(repFile,'X_noise','X_noNoise','A_real');
load(networkFile,'id_cell');


% infer gene communities    
    % no noise case
len_X_noNoise = length(X_noNoise);
numPreEdge_noNoise = zeros(len_X_noNoise,1);
numBingo_noNoise = zeros(len_X_noNoise,1);
acc_noNoise = zeros(len_X_noNoise,1);
id_cluster_noNoise = cell(len_X_noNoise,1);
A_noNoise = cell(len_X_noNoise,1);
for ii = 1:1  %len_X_noNoise    
    fprintf(1,'---No noise. Test %d ---\n',ii);
    [A_noNoise{ii} id_cluster_noNoise{ii}]= geneNetwork_community(X_noNoise{ii},gamma1_v,gamma1_terminate);
    [numPreEdge_noNoise(ii), numBingo_noNoise(ii), acc_noNoise(ii)] = accuracy_network(A_real,A_noNoise{ii},pre);
end

    % noise case
len_X_noise = length(X_noise);    
numPreEdge_noise = zeros(len_X_noise,1);
numBingo_noise = zeros(len_X_noise,1);
acc_noise = zeros(len_X_noise,1);
id_cluster_noise = cell(len_X_noise,1);
A_noise = cell(len_X_noise,1);
for ii = 1:1 %len_X_noise    
    fprintf(1,'--- Noise case. Test %d ---\n',ii);
    [A_noise{ii} id_cluster_noise{ii}]= geneNetwork_community(X_noise{ii},gamma1_v,gamma1_terminate);
    [numPreEdge_noise(ii), numBingo_noise(ii), acc_noise(ii)] = accuracy_network(A_real,A_noise{ii},pre);
end

save(resultFile,'numPreEdge_noNoise','numBingo_noNoise','acc_noNoise', 'A_noNoise','id_cluster_noNoise',...
                'numPreEdge_noise',  'numBingo_noise',  'acc_noise',   'A_noise',  'id_cluster_noise');
%load(resultFile,'numPreEdge_noNoise','numBingo_noNoise','acc_noNoise','A_noNoise','id_cluster_noNoise');
outputClusterResult(clusterFile,id_cluster_noNoise{1},id_cell);
outputGeneNetwork(outputNetworkFile,A_noNoise{1},id_cell);
