% main_geneNetwork_Wu

% test method of Wu Fang-Xiang;

repFile = '../data/rep_matrix_hammer_14_nodes.mat';
resultFile = '../iteration/accuracy_method_Wu.mat';

load(repFile,'X_noise','X_noNoise','A_real');
n = size(A_real,2);
W = zeros(n,n);
len_X_noise = length(X_noise);
len_X_noNoise = length(X_noNoise);

gamma1_noNoise = 0.02;
gamma1_noise = 0.02;
gamma2 = 0;
pre = 0.1;

% no noise case
numPreEdge_noNoise = zeros(len_X_noNoise,1);
numBingo_noNoise = zeros(len_X_noNoise,1);
acc_noNoise = zeros(len_X_noNoise,1);
for ii = 1:len_X_noNoise    
    A = geneNetwork(X_noNoise{ii},W,gamma1_noNoise,gamma2);
    [numPreEdge_noNoise(ii), numBingo_noNoise(ii), acc_noNoise(ii)] = accuracy_network(A_real,A,pre);
end

% noise case
numPreEdge_noise = zeros(len_X_noise,1);
numBingo_noise = zeros(len_X_noise,1);
acc_noise = zeros(len_X_noise,1);
for ii = 1:len_X_noNoise    
    A = geneNetwork(X_noise{ii},W,gamma1_noise,gamma2);
    [numPreEdge_noise(ii), numBingo_noise(ii), acc_noise(ii)] = accuracy_network(A_real,A,pre);
end

save(resultFile,'numPreEdge_noNoise','numPreEdge_noise','numBingo_noise','numBingo_noNoise','acc_noNoise','acc_noise');

