% test  geneNetwork() on hammer14 data

% argument
noise_mode = 1; % 1: noise case; 0: no noise case; 2: run on both the two cases
NCI_multi_gamma = 1; % 1: search the community with several values of parameter gamma;
                % 0: serch the community with a single value of gamma;
max_num_run_data_set = 2; % [];
     % maximum number of data sets to repeat the algorithm 
     % set [] to run all the data sets of the generated gene expression
     % matrices X 

if NCI_multi_gamma
    gamma1_v = [0.05 0.02 0.008];
else
    gamma1_v = 0.02;
end
gamma1_terminate = 0.02;
pre = 0.1;

% result file name
str = ['_' date()]; %'';
if NCI_multi_gamma
    resultFile = sprintf('../iteration/cluster_accuracy_hammer_14_nodes%s.mat',str);
else
    resultFile = sprintf('../iteration/cluster_accuracy_single_sol_hammer_14_nodes%s.mat',str);
end

% load gene reperesentation matrices 
repFile = '../data/rep_matrix_hammer_14_nodes.mat';
load(repFile,'X_noise','X_noNoise','A_real');

% infer gene communities    
if noise_mode==0 || noise_mode==2
        % no noise case
    len_X_noNoise = length(X_noNoise);     
    if ~isempty(max_num_run_data_set)
        len_X_noNoise = min(max_num_run_data_set,length(X_noNoise));
    end
    numPreEdge_noNoise = zeros(len_X_noNoise,1);
    numBingo_noNoise = zeros(len_X_noNoise,1);
    acc_noNoise = zeros(len_X_noNoise,1);
    id_cluster_noNoise = cell(len_X_noNoise,1);
    A_noNoise = cell(len_X_noNoise,1);
    for ii = 1:len_X_noNoise   
        fprintf(1,'---No noise. Test %d ---\n',ii);
        [A_noNoise{ii} id_cluster_noNoise{ii}]= geneNetwork_community(X_noNoise{ii},gamma1_v,gamma1_terminate);
        [numPreEdge_noNoise(ii), numBingo_noNoise(ii), acc_noNoise(ii)] = accuracy_network(A_real,A_noNoise{ii},pre);
    end
    save(resultFile,'numPreEdge_noNoise','numBingo_noNoise','acc_noNoise','A_noNoise','id_cluster_noNoise');
end

if noise_mode==1 || noise_mode==2
    % noise case
    len_X_noise = length(X_noise);     
    if ~isempty(max_num_run_data_set)
        len_X_noise = min(max_num_run_data_set,length(X_noise));    
    end
    numPreEdge_noise = zeros(len_X_noise,1);
    numBingo_noise = zeros(len_X_noise,1);
    acc_noise = zeros(len_X_noise,1);
    id_cluster_noise = cell(len_X_noise,1);
    A_noise = cell(len_X_noise,1);
    for ii = 1:len_X_noise       
        fprintf(1,'--- Noise case. Test %d ---\n',ii);
        [A_noise{ii} id_cluster_noise{ii}]= geneNetwork_community(X_noise{ii},gamma1_v,gamma1_terminate);
        [numPreEdge_noise(ii), numBingo_noise(ii), acc_noise(ii)] = accuracy_network(A_real,A_noise{ii},pre);
    end
    if exist(resultFile,'file')
        save(resultFile,'numPreEdge_noise','numBingo_noise','acc_noise','A_noise','id_cluster_noise','-append');
    else
        save(resultFile,'numPreEdge_noise','numBingo_noise','acc_noise','A_noise','id_cluster_noise');
    end
end

fprintf('Finished to solve. See ''%s'' for the result.\n', resultFile);
