% 1. compare the accuracy of the gene network by local community and by the
%       method of Wu
% 2. show the effect of searching multiple gene networks

OBJECT_1 = 0;
OBJECT_2 = 1;
OBJECT_3 = 0;

resultFile_com = '../iteration/cluster_accuracy_hammer_14_nodes.mat';
resultFile_Wu = '../iteration/accuracy_method_Wu.mat';
resultFile_single = '../iteration/cluster_accuracy_single_sol_hammer_14_nodes.mat';

% load accuracies
load(resultFile_com,'numPreEdge_noNoise','numBingo_noNoise','acc_noNoise','A_noNoise','id_cluster_noNoise',...
    'numPreEdge_noise','numBingo_noise','acc_noise','A_noise','id_cluster_noise');
acc_noNoise_com = acc_noNoise; acc_noise_com = acc_noise;
numPre.noNoise_com = numPreEdge_noNoise; numPre.noise_com = numPreEdge_noise; 
numBingo.noNoise_com = numBingo_noNoise; numBingo.noise_com = numBingo_noise; 


load(resultFile_Wu,'numPreEdge_noNoise','numPreEdge_noise','numBingo_noise','numBingo_noNoise','acc_noNoise','acc_noise');
acc_noNoise_Wu = acc_noNoise; acc_noise_Wu = acc_noise;
numPre.noNoise_Wu = numPreEdge_noNoise; numPre.noise_Wu = numPreEdge_noise; 
numBingo.noNoise_Wu = numBingo_noNoise; numBingo.noise_Wu = numBingo_noise; 


load(resultFile_single,'numPreEdge_noNoise','numPreEdge_noise','numBingo_noise','numBingo_noNoise','acc_noNoise','acc_noise');
acc_noNoise_single = acc_noNoise; acc_noise_single = acc_noise;
numPre.noNoise_single = numPreEdge_noNoise; numPre.noise_single = numPreEdge_noise; 
numBingo.noNoise_single = numBingo_noNoise; numBingo.noise_single = numBingo_noise; 



len_acc_noNoise = length(acc_noNoise);
len_acc_noise = length(acc_noise);

% 1. show the accuracies of the proposed community-based gene network (CGN)
if OBJECT_1
  % noNoise case
x = 1:len_acc_noNoise;
hold on
plot(x,acc_noNoise_com,'ok','MarkerSize',10);
plot(x,acc_noNoise_Wu,'*k','MarkerSize',8);
legend('NCI','SGN');
xlabel('experiments');
ylabel('accuracy');
%title('accuracy of the predicted gene network');
hold off
saveas(gcf,'../figure/fig_acc_network_noNoise.fig');
saveas(gcf,'../figure/fig_acc_network_noNoise.eps', 'psc2');
close(gcf);

  % noise case
x = 1:len_acc_noise;
hold on
plot(x,acc_noise_com,'ok','MarkerSize',10);
plot(x,acc_noise_Wu,'*k','MarkerSize',8);
legend('NCI','SGN');
hold off
xlabel('experiments');
ylabel('accuracy');
saveas(gcf,'../figure/fig_acc_network_noise.fig');
saveas(gcf,'../figure/fig_acc_network_noise.eps', 'psc2');
close(gcf);
end

% 2. show the accuracies of the CGN just searching single gene network 
if OBJECT_2    
  % noNoise case
x = 1:len_acc_noNoise;
hold on
plot(x,acc_noNoise_com,'ok','MarkerSize',10);
plot(x,acc_noNoise_single,'*k','MarkerSize',8);
legend('NCI','NCI-single');
xlabel('experiments');
ylabel('accuracy');
hold off
  % save the figures
saveas(gcf,'../figure/fig_acc_network_single_noNoise.fig');
saveas(gcf,'../figure/fig_acc_network_single_noNoise.eps', 'psc2');
close(gcf);

  % noise case
x = 1:len_acc_noise;
hold on
plot(x,acc_noise_com,'ok','MarkerSize',10);
plot(x,acc_noise_single,'*k','MarkerSize',8);
legend('NCI','NCI-single');
xlabel('experiments');
ylabel('accuracy');
hold off
saveas(gcf,'../figure/fig_acc_network_single_noise.fig');
saveas(gcf,'../figure/fig_acc_network_single_noise.eps', 'psc2');
close(gcf);
end

% 3. show the number of predicted edges and shot edges
if OBJECT_3
    % noNoise case    
    A{1} = [numPre.noNoise_com  numPre.noNoise_Wu];
    A{2} = [numBingo.noNoise_com  numBingo.noNoise_Wu];    
    wid = 0.5;
    x = 1:len_acc_noNoise;    
    bar1=bar(x, A{1},  'EdgeColor', 'k'); %'FaceColor', 'b',
    set(bar1,'BarWidth',wid);
    %legend('CGN','SGN');
    wid = wid * 0.5;
    hold on
    bar1=bar(x, A{2}, 'FaceColor', 'r', 'EdgeColor', 'r'); 
    set(bar1,'BarWidth',wid);    
    hold off
    legend('CGN','SGN','#correct edges');
    set(gca,'XLim',[0 len_acc_noNoise+1],'Layer','top');    
    saveas(gcf,'../figure/fig_num_noNoise_Wu.fig');
    saveas(gcf,'../figure/fig_num_noNoise_Wu.eps', 'psc2');    
end

